/********************************************************************/
/*  7188XC + X102 head file                                         */
/*                                                                  */
/*  [12/October/2005] by Liam                                       */
/*  [15/Dec/2006] by Liam                                           */
/********************************************************************/
/********************************************************************/
/*  X102:  2 channels Relay Output                                  */
/********************************************************************/

#ifndef __X102_H
#define __X102_H

#ifdef __cplusplus
extern "C" {
#endif

int X102_Init(void);
/*  Always return 0 */

unsigned X102_GetLibVersion(void);
/*  Current version is 2.00 (return 0x0200) */

void X102_Write_All_DO(int iOutValue);
/*  iOutValue: 0x00 ~ 0x03  */

void X102_Write_One_DO(int iChannel, int iStatus);
/*  iChannel = 0 ~ 1
    iStatus = 1 => Status is ON
    iStatus = 0 => Status is OFF    */

int X102_Read_All_DO(void);
/*  Return data = 0x00 ~ 0x03   */

int X102_Read_One_DO(int iChannel);
/*  iChannel = 0 ~ 1
    Return 1 => ON
    Return 0 => OFF */

#ifdef __cplusplus
}
#endif

#endif
