/*
X101Demo.c: Demo program for X101 board.

Compiler: BC++ 3.1, 
          Turbo C ++ 1.01(3.01) (free from http://community.borland.com/museum)

Compile mode: large

Project: X101Demo.c
         ..\..\Lib\7188xcl.lib
         ..\..\LIB\Xboard\X101.lib
         
Hardware: 7188XC + X101
X101: Digital Output: 8 Channels
    
[11/July/2005] by Liam
*/

#include<conio.h>
#include "..\..\lib\7188xc.h"
#include "..\..\LIB\Xboard\X101.h"

void main(void)
{
    int iAction, iStatus, iDOValue=0, iOutChannel, iRet, quit;
    
    InitLib();
    X101_Init();    //Initialize the X101

    Print("\r\n");
    Print("***************************************\r\n");
    Print("|    Demo program for 7188XC + X101   |\r\n");
    Print("|                                     |\r\n");
    Print("|            [11/July/2005]           |\r\n");
    Print("***************************************\r\n");

    while(iAction!=5)
    {
        iAction=0;
        quit=0;
        
        Puts("\r\n");
        Puts("1) Write DO (all channels)\r\n");
        Puts("2) Write DO (one channel)\r\n");
        Puts("3) DO Readback (all channels)\r\n");
        Puts("4) DO Readback (one channel)\r\n");
        Puts("\n\r");
        Puts("5) Quits demo program\n\r\n\r");
        Puts("Choose an option and press [Enter]:");
        Scanf("%d", &iAction);
        Puts("\r\n");
        
        switch(iAction)
        {
            //Write all Digital Output channels
            case 1:
                Print("Please input Output value(0 ~ 0x00ff): ");
                Scanf("%x", &iDOValue);
                
                X101_Write_All_DO(iDOValue);

                Print("Output value=> 0x%04x\r\n\r\n", iDOValue);
            break;
            //Write single Digital Output channel
            case 2:
                Print("Please select outport channel(0~7) and status(0:OFF, 1:ON)\r\n");
                Print("Channel number and status:");
                
                Scanf("%d %d", &iOutChannel, &iStatus);
                
                if(iOutChannel>7)
                {
                    Puts("Unknow Channel Number!!\r\n\r\n");
                    break;
                }
                
                X101_Write_One_DO(iOutChannel, iStatus);
                                
                Print("Channel %d ==> %s\r\n\r\n", iOutChannel, (iStatus>0)?"ON":"OFF");
            break;
            //Read all Digital Output channels
            case 3:
                iDOValue=X101_Read_All_DO();
                
                Print("Digital Output ReadBack=> 0x%04x\r\n\r\n", iDOValue);
            break;
            //Read single Digital Output channel
            case 4:
                Print("Please select outport channel(0~7): ");
                Scanf("%d", &iOutChannel);
                
                if(iOutChannel>7)
                {
                    Puts("Unknow Channel Number!!\r\n\r\n");
                    break;
                }
                
                iRet=X101_Read_One_DO(iOutChannel);
                 
                if(iRet)
                    Print("Channel %d ==> ON\r\n\r\n", iOutChannel);
                else
                    Print("Channel %d ==> OFF\r\n\r\n", iOutChannel);
            break;
            
            case 5:
            default:
                quit=1;
            break;
        }
        if(!quit)
        {
            Puts("Press any key to continue...\r\n");
            Getch();
        }
    }
}
